#pragma once

#include <string>

#include "../path.h"
#include "../misc.h"

namespace cppfs
{

    struct file
    {
    private:
        cppfs::path _path;

    public:
        /**
         * @brief Constructor.
         */
        template<typename... T_args>
        inline file(T_args&&... p_args);

        /**
         * @brief Get the path of the file.
         */
        inline const cppfs::path& path() const;

        /**
         * @brief Check if the file exsists.
         */
        inline bool exists() const;

        /**
         * @brief Remove the file.
         */
        inline const file& remove() const;
    };

}
