#pragma once

#include "file.h"

namespace cppfs
{

    /* file */

    template<typename... T_args>
    file::file(T_args&&... p_args)
        : _path(std::forward<T_args>(p_args)...)
        { }

    const cppfs::path& file::path() const
        { return _path; }

    bool file::exists() const
        { return _path.is_file(); }

}
