#include <gtest/gtest.h>

#include <cppfs.h>

using namespace ::testing;
using namespace ::cppfs;

TEST(directory_tests, create)
{
    EXPECT_ANY_THROW(directory("/fuu/bar/baz").create(false));

    EXPECT_FALSE(directory("/tmp/fuu/bar/baz").exists());
    directory("/tmp/fuu/bar/baz").create(true).remove(false);
}

TEST(directory_tests, exists)
{
    EXPECT_TRUE (directory("./cppfs").exists());
    EXPECT_FALSE(directory("./cppfs/directory_tests.cpp").exists());
}

TEST(directory_tests, iterator)
{
    directory dir("./cppfs");

    std::vector<std::string> files;
    std::transform(dir.begin(), dir.end(), std::back_inserter(files), [](auto& e) { return e.name; });
    std::sort(files.begin(), files.end());

    EXPECT_EQ(
        files,
        std::vector<std::string>({
            "directory_tests.cpp",
            "path_tests.cpp",
        }));
}
